function CalcPhaseAdvances(handles)
% Calculates the phase advances in 2 dimensions and displays them
IF = str2double(get(handles.edtIF,'String'));
ID = str2double(get(handles.edtIF,'String'));

betaX = str2double(get(handles.edtBetaX,'String'));
alphaX = str2double(get(handles.edtAlphaX,'String'));
betaY = str2double(get(handles.edtBetaY,'String'));
alphaY = str2double(get(handles.edtAlphaY,'String'));

energy = str2double(get(handles.txtEnStartVal,'String'));

[muX, muY, betaX, betaY] = FodoSwissFromI(IF, ID, betaX, alphaX, betaY, alphaY, energy);
set(handles.txtPhaseAdvXVal,'String',num2str(muX));
set(handles.txtPhaseAdvYVal,'String',num2str(muY));