function I = DisplayFodoIUsingPhi(handles)
% Input values
E = str2double(get(handles.txtEnStartVal, 'String'));
phiH = pi/180 * str2double(get(handles.edtPhaseAdvXVal, 'String'));
phiV = pi/180 * str2double(get(handles.edtPhaseAdvYVal, 'String'));

% Minimization options
tolerance = 1e-8;
iterations = 10000;
options = [0; tolerance; 0; 0; 0; 0; 0; 0; 0; iterations];

% Find IF and ID by minimization
I = fmins('merit_function_phis',[1 1], options, [], E, phiH, phiV);
set(handles.edtIF, 'String', num2str(I(1), '%4.2f'));
set(handles.edtID, 'String', num2str(I(2), '%4.2f'));