function MakeListOfDevices()
% Generates a standarized list of devices and stores it globally, used
% for reading values other places

% global G_quads, global G_dipols, global G_hcors, global G_vcors, global G_mons, global G_movers;
global G_quads, global G_dipols, global G_hcors, global G_vcors, global G_mons, global G_hmovers, global G_vmovers;

% Use the predefined lists
[tl2_quads, tl2_dipols, tl2_hcors, tl2_vcors, tl2_mons] = tl2();
[tl2p_quads, tl2p_dipols, tl2p_hcors, tl2p_vcors, tl2p_mons] = tl2prime();
[tbl_quads, tbl_dipols, tbl_hcors, tbl_vcors, tbl_hmovers, tbl_vmovers, tbl_mons] = tbl();

G_quads = [tl2_quads(length(tl2_quads)-3:length(tl2_quads)), tbl_quads];
G_dipols = [tl2p_dipols(1), tbl_dipols];
G_hcors = [tl2_hcors(length(tl2_hcors)), tbl_hcors];
G_vcors = [tl2_vcors(length(tl2_vcors)), tbl_vcors];
G_mons = [tl2_mons(length(tl2_mons)), tbl_mons];
G_hmovers = tbl_hmovers;
G_vmovers = tbl_vmovers;