function ReadPowerPulsesAndDisplay(handles)
global G_isonline;
global G_iq_slope_1; global G_iq_slope_2;
global G_iq_N_1, global G_iq_N_2;
global G_iq_phi_1, global G_iq_phi_2;
global G_iq_attenuation_total_1; global G_iq_attenuation_total_2;
% global G_movers;
global G_savedpulses;
global G_path;

% Vaiables
saveJavaSignals = 1;

% timeTotal = tic;

% Y scaling in plots
%YMaxCur = 5;
%YMaxRf = 2;

% Show X range
% XRng = [1500 1950];
XRng = [0 2500];
windowRf = 55:150;
shiftRf = 360;
scaleRf = 1;

%% Make struct of devices
% All control devices where the 'samples' property is read
try
    control(1).name = 'CB.SVBPM0150H'; control(1).property = 'Samples'; control(1).field = 'samples';
    control(2).name = 'CB.SVBPM0150S'; control(2).property = 'Samples'; control(2).field = 'samples';
    control(3).name = 'CB.SVBPM0150V'; control(3).property = 'Samples'; control(3).field = 'samples';
    control(4).name = 'CB.SVBPS0210H'; control(4).property = 'Samples'; control(4).field = 'samples';
    control(5).name = 'CB.SVBPS0210S'; control(5).property = 'Samples'; control(5).field = 'samples';
    control(6).name = 'CB.SVBPS0210V'; control(6).property = 'Samples'; control(6).field = 'samples';
    control(7).name = 'CB.SVBPS0250H'; control(7).property = 'Samples'; control(7).field = 'samples';
    control(8).name = 'CB.SVBPS0250S'; control(8).property = 'Samples'; control(8).field = 'samples';
    control(9).name = 'CB.SVBPS0250V'; control(9).property = 'Samples'; control(9).field = 'samples';
    control(10).name = 'CB.SVBPS0310H'; control(10).property = 'Samples'; control(10).field = 'samples';
    control(11).name = 'CB.SVBPS0310S'; control(11).property = 'Samples'; control(11).field = 'samples';
    control(12).name = 'CB.SVBPS0310V'; control(12).property = 'Samples'; control(12).field = 'samples';
    control(13).name = 'CB.SVBPS0350H'; control(13).property = 'Samples'; control(13).field = 'samples';
    control(14).name = 'CB.SVBPS0350S'; control(14).property = 'Samples'; control(14).field = 'samples';
    control(15).name = 'CB.SVBPS0350V'; control(15).property = 'Samples'; control(15).field = 'samples';
    control(16).name = 'CB.SVBPS0410S'; control(16).property = 'Samples'; control(16).field = 'samples';
    control(17).name = 'CB.SVBPS0450S'; control(17).property = 'Samples'; control(17).field = 'samples';
    control(18).name = 'CB.SVBPS0510S'; control(18).property = 'Samples'; control(18).field = 'samples';
    control(19).name = 'CB.SVBPS0550S'; control(19).property = 'Samples'; control(19).field = 'samples';
    control(20).name = 'CB.SVBPS0610S'; control(20).property = 'Samples'; control(20).field = 'samples';
    control(21).name = 'CB.SVBPS0650S'; control(21).property = 'Samples'; control(21).field = 'samples';
    control(22).name = 'CB.SVBPS0710S'; control(22).property = 'Samples'; control(22).field = 'samples';
    control(23).name = 'CB.SVBPS0750S'; control(23).property = 'Samples'; control(23).field = 'samples';
    control(24).name = 'CB.SVBPS0810S'; control(24).property = 'Samples'; control(24).field = 'samples';
    control(25).name = 'CB.SVBPS0850S'; control(25).property = 'Samples'; control(25).field = 'samples';
    control(26).name = 'CB.SVBPS0910S'; control(26).property = 'Samples'; control(26).field = 'samples';
    control(27).name = 'CB.SVBPS0950S'; control(27).property = 'Samples'; control(27).field = 'samples';
    control(28).name = 'CB.SVBPM1030S'; control(28).property = 'Samples'; control(28).field = 'samples';
    control(29).name = 'CC.SABPR0915W'; control(29).property = 'Samples'; control(29).field = 'samples';
    control(30).name = 'CC.SABPR0915H'; control(30).property = 'Samples'; control(30).field = 'samples';
    control(31).name = 'CC.SABPR0915S'; control(31).property = 'Samples'; control(31).field = 'samples';
    control(32).name = 'CC.SABPR0915V'; control(32).property = 'Samples'; control(32).field = 'samples';
    control(33).name = 'CL.SABPR0290W'; control(33).property = 'Samples'; control(33).field = 'samples';
    control(34).name = 'CL.SABPR0475W'; control(34).property = 'Samples'; control(34).field = 'samples';
    control(35).name = 'CT.SABPR0532W'; control(35).property = 'Samples'; control(35).field = 'samples';
    control(36).name = 'CR.SABPR0505W'; control(36).property = 'Samples'; control(36).field = 'samples';
    control(37).name = 'CL.SVBLM10S1'; control(37).property = 'Samples'; control(37).field = 'samples';
    control(38).name = 'CL.SVBLM10S2'; control(38).property = 'Samples'; control(38).field = 'samples';
    control(39).name = 'CL.SVBLM10S3'; control(39).property = 'Samples'; control(39).field = 'samples';
    control(40).name = 'CL.SVBLM10S4'; control(40).property = 'Samples'; control(40).field = 'samples';
    control(41).name = 'CL.SVBLM08S1'; control(41).property = 'Samples'; control(41).field = 'samples';
    control(42).name = 'CL.SVBLM08S2'; control(42).property = 'Samples'; control(42).field = 'samples';
    control(43).name = 'CL.SVBLM08S3'; control(43).property = 'Samples'; control(43).field = 'samples';
    control(44).name = 'CL.SVBLM08S4'; control(44).property = 'Samples'; control(44).field = 'samples';
    control(45).name = 'CR.PHAS-BPR0915'; control(45).property = 'Acquisition'; control(45).field = 'phase_Val';

    % Remove special characters from variable names
    for i = 1:length(control)
        control(i).varname = control(i).name;
        control(i).varname(strfind(control(i).varname, '.')) = '_';
        control(i).varname(strfind(control(i).varname, '-')) = '_';
    end
catch
    s = lasterror;
    disp(['Error when making struct of devices: ' s.message]);
end

% Variables
devicesToPlot = 1:6;
devicesToReadFromCtrl = 45;

%% Read pulses
if G_isonline
    % Read BPM signals
    try
        foldername = [G_path '/BPMOutput/'];
        
        for i = 1:length(control)
            if strcmp(control(i).field, 'samples')
                fid = fopen([foldername control(i).name]);
                control(i).timestamp = str2double(fgetl(fid));
                fscanf(fid, '%c', 14);  % Ignore the BPM name
                eval([control(i).varname '= fscanf(fid, ''%f'');']);
                fclose(fid);
            end
        end
        
        % Read mean BPM values
        fid = fopen([foldername 'mean.txt']);
        meantime = str2double(fgetl(fid));
        meandata = textscan(fid, '%s %f');
        meannames = meandata{:,1}';
        meanvals = meandata{:,2}';
        meanvals(isnan(meanvals)) = 0;
        fclose(fid);
    catch
        s = lasterror;
        disp(['Error when reading BPM samples: ' s.message]);
    end
    
    % Read power signals
    try
        IQRawI1  = AcqirisGet('CE.SCOPE03.CH01');
        timestampI1 = fesaget( 'CE.SCOPE03.CH01','Acquisition','acqStamp');
        IQRawQ1  = AcqirisGet('CE.SCOPE03.CH02');
        timestampQ1 = fesaget( 'CE.SCOPE03.CH02','Acquisition','acqStamp');
        IQRawI2  = AcqirisGet('CE.SCOPE03.CH03');
        timestampI2 = fesaget( 'CE.SCOPE03.CH03','Acquisition','acqStamp');
        IQRawQ2  = AcqirisGet('CE.SCOPE03.CH04');
        timestampQ2 = fesaget( 'CE.SCOPE03.CH04','Acquisition','acqStamp');
        

        PRefl1 = AcqirisGet('CE.SCOPE04.CH03');
        PRefl2 = AcqirisGet('CE.SCOPE04.CH04');
    catch
        s = lasterror;
        disp(['Error when reading rf signals: ' s.message]);
    end
    
    if (length(IQRawI1) >= 10) && (length(IQRawQ1) >= 10) && (length(IQRawI2) >= 10) && (length(IQRawQ2) >= 10)
        % Subtract offsets
        Ipout1 = IQRawI1 - mean(IQRawI1(1:10))*ones(size(IQRawI1));
        Qpout1 = IQRawQ1 - mean(IQRawQ1(1:10))*ones(size(IQRawQ1));
        Ipout2 = IQRawI2 - mean(IQRawI2(1:10))*ones(size(IQRawI2));
        Qpout2 = IQRawQ2 - mean(IQRawQ2(1:10))*ones(size(IQRawQ2));
    else
        disp('Some rf signals have less than 10 samples.');
    end
    
    % Use IQ calibration parameters
    try
    Pout1new = Ipout1.^2 + (G_iq_N_1/cos(G_iq_phi_1)*Qpout1 - Ipout1*tan(G_iq_phi_1)).^2;
    Pout2new = Ipout2.^2 + (G_iq_N_2/cos(G_iq_phi_2)*Qpout2 - Ipout2*tan(G_iq_phi_2)).^2;
    Pin1 = Pout1new * G_iq_slope_1;
    Pin2 = Pout2new * G_iq_slope_2;
    powPulseR = Pin1 * 10^(G_iq_attenuation_total_1/10) / 1e6;
    powPulseL = Pin2 * 10^(G_iq_attenuation_total_2/10) / 1e6;
    
    % Phase
    phaseR = atan(Qpout1./Ipout1) * 180/pi;
    phaseL = atan(Qpout2./Ipout2) * 180/pi;
    shiftPhase = (phaseR(windowRf(round(end/2))) - phaseL(windowRf(round(end/2))));
    catch
        s = lasterror;
        disp(['Error when applying rf calibration parameters: ' s.message]);
    end
else
    CB_SVBPS0210S = [rand(1,37), 28*ones(1,50)+randn(1,50), rand(1,13)];
    CB_SVBPS0250S = [rand(1,37), 24*ones(1,50)+randn(1,50), rand(1,13)];
    CB_SVBPS0210H = [0.1*randn(1,300), ones(1,100)+0.1*randn(1,100), 0.1*randn(1,112)];
    CB_SVBPS0250H = [0.1*randn(1,300), -1.8*ones(1,100)+0.1*randn(1,100), 0.1*randn(1,112)];
    CB_SVBPS0210V = [0.1*randn(1,300), 1.1*ones(1,100)+0.1*randn(1,100), 0.1*randn(1,112)];
    CB_SVBPS0250V = [0.1*randn(1,300), -1.9*ones(1,100)+0.1*randn(1,100), 0.1*randn(1,112)];
    powPulseL = [rand(1,35), 35+5*randn(1,2), 67*ones(1,50)+2*randn(1,50), 25+5*randn(1,1), 2*rand(1,12)];
    powPulseR = [rand(1,35), 35+5*randn(1,2), 67*ones(1,50)+2*randn(1,50), 25+5*randn(1,1), 2*rand(1,12)];
end

%% Detect pulse edges
commonBpm = CB_SVBPS0210S;
try
    maxRf = max(powPulseL);
    maxBpm = min(commonBpm);
    edgesRf = [1 length(powPulseL)];
    edgesBpm = [1 length(commonBpm)];
    if max(powPulseL) > 0.1
        for i = 1:length(powPulseL)
            if powPulseL(i) > 0.05*maxRf
                edgesRf(1) = i;
                break;
            end
        end
        for i = length(powPulseL):-1:edgesRf(1)+1
            if powPulseL(i) > 0.05*maxRf
                edgesRf(2) = i;
                break;
            end
        end
        windowRf = edgesRf(1)+round(0.25*(edgesRf(2)-edgesRf(1))) : edgesRf(2)-round(0.25*(edgesRf(2)-edgesRf(1)));
        %disp(num2str(windowRf([1 end])));
        
        for i = 1:length(commonBpm)
            if commonBpm(i) < 0.1*maxBpm
                edgesBpm(1) = i;
                break;
            end
        end
        for i = length(commonBpm):-1:edgesBpm(1)+1
            if commonBpm(i) < 0.1*maxBpm
                edgesBpm(2) = i;
                break;
            end
        end
    end
catch
    s = lasterror;
    disp(['Error when detecting pulse edges: ' s.message]);
end

%% Save pulses
totalpulses = str2double(get(handles.edtSavePulses, 'String'));

% Save pulses if the Save button is on
if (get(handles.btnSavePulses, 'Value') == 1)
    if G_savedpulses < totalpulses
        try
            % Get BPM signals directly from control system if flag is set (because of timing)
            if ~saveJavaSignals
                for i = 7:19
                    eval([control(i).varname ' = ReadXenericSampler(control(i).name, ''' control(i).property ''', ''' control(i).field ''');']);
                end
            end
            
            % Signals that will be saved from the control system in any case
            for i = devicesToReadFromCtrl
                eval([control(i).varname ' = ReadXenericSampler(control(i).name, ''' control(i).property ''', ''' control(i).field ''');']);
            end
        catch
            s = lasterror;
            disp(['Error when reading from control system: ' s.message]);
        end
        
        try
        if control(1).timestamp > 1e3 % If the timestamp is read correctly
            filename = ['saved_pulses/tbl_', num2str(control(1).timestamp), '.mat'];
        else
            filename = ['saved_pulses/tbl_fail', num2str(round(1e3*rand(1,1))), '.mat'];
        end
        
        save(filename, 'control', '*BP*', 'timestamp*', 'IQRaw*', '*PHAS*', '*BLM*',  'mean*', 'PRefl*', 'time*', 'saveJava*');
        G_savedpulses = G_savedpulses + 1;
        
        savestring = ['Saving Pulses... ' num2str(G_savedpulses, '%3.0f') '/' num2str(totalpulses, '%3.0f')];
        disp(savestring);
        set(handles.txtSavePulsesWait, 'Visible', 'on', 'ForegroundColor', 'red', 'String', savestring);
        catch
            s = lasterror;
            disp(['Error when saving: ' s.message]);
        end
        pause(0.001);   % Trying this for updating the text
    end
    if G_savedpulses >= totalpulses
        % Reset saving button after finished
        set(handles.edtSavePulses, 'Enable', 'on');
        set(handles.btnSavePulses, 'Value', 0);
        set(handles.txtSavePulsesWait, 'Visible', 'off');
    end
end

% toc(timeTotal);

%% Plotting
% Set NaN values to 0 to have something to plot
try
    for i = devicesToPlot
        eval([control(i).varname '(isnan(' control(i).varname ')) = 0;']);
    end
catch
    s = lasterror;
    disp(['Error when changing NaN values to 0: ' s.message]);
end

try
    samples_bpm = eval( ['size(' control(2).varname ', 1);'] );
    samples_rf = size(IQRawI1, 1);
catch
    samples_bpm = 1;
    samples_rf = 1;
end
t_bpm = 2664;   % [ns]

% x_bpm = (1:512) / 512 * 2664;
% x_rf = (1:500);
% x_rf = x_rf + 1407 * ones(size(x_rf));     % Move pulse

try
    % Make sure that vectors have the correct lengths, scale the x axis by the sampling rate
    if (length(CB_SVBPS0210S) > 1) && (length(CB_SVBPS0250S) == length(CB_SVBPS0210S))
    %     xrange_bpm = (0:length(bpm0210S)-1) / srate_cur;
        xrange_bpm = (1:samples_bpm) / samples_bpm * t_bpm;
    else
        xrange_bpm = 0;
        CB_SVBPS0210S = 0;
        CB_SVBPS0250S = 0;
    end

    if (length(powPulseL) > 1) && (length(powPulseL) == length(powPulseR))
    %     xrange_power = (0:length(powPulseL)-1) / srate_pow;
        xrange_power = (1:samples_rf) * scaleRf;
        xrange_power = xrange_power + shiftRf * ones(size(xrange_power));     % Move pulse
    else
        xrange_power = 0;
        powPulseL = 0;
        powPulseR = 0;
    end

        xspace = 0.1*(edgesBpm(2)-edgesBpm(1));
        xl = [edgesBpm(1)-xspace edgesBpm(2)+xspace] / samples_bpm*t_bpm;
catch
    s = lasterror;
    disp(['Error when making X ranges: ' s.message]);
end

% Plot intensity
try
    if length(CB_SVBPS0210S) == length(xrange_bpm) && length(CB_SVBPS0250S) == length(xrange_bpm)
        cla(handles.axPowCurPulses);
        hold(handles.axPowCurPulses, 'on');
        plot(handles.axPowCurPulses, xrange_bpm, CB_SVBPS0210S, '.-', 'Color', [0.626 0.322 0.177]);
        plot(handles.axPowCurPulses, xrange_bpm, CB_SVBPS0250S, '.-', 'Color', [0.0 0.745 0.433]);
        hold(handles.axPowCurPulses, 'off');
        
        set(handles.axPowCurPulses, 'XLim', xl, 'YLim', [floor(1.1*maxBpm) 0], ...
            'YGrid', 'on', 'XGrid', 'on');
        set(get(handles.axPowCurPulses, 'YLabel'), 'String', 'Current [A]');
        set(get(handles.axPowCurPulses, 'XLabel'), 'String', 'Time [ns]');
        legend(handles.axPowCurPulses, control(5).name, control(8).name, 'Location', 'NorthEast');
    end
catch
    s = lasterror;
    disp(['Error when plotting current: ' s.message]);
end

% Show numerical values
try
    powValL = mean(powPulseL(windowRf));
    powValR = mean(powPulseR(windowRf));
    set(handles.txtPowerMeasLVal, 'String', num2str(powValL, '%6.2f'));
    set(handles.txtPowerMeasRVal, 'String', num2str(powValR, '%6.2f'));
    set(handles.txtPowerMeasTotVal, 'String', num2str(powValL+powValR, '%6.2f'));
    set(handles.txtPowerMeasReflLVal, 'String', num2str(max(PRefl1), '%6.3f'));
    set(handles.txtPowerMeasReflRVal, 'String', num2str(max(PRefl2), '%6.3f'));

    if length(meanvals) == 57
        set(handles.txtCurMeas210Val, 'String', num2str(meanvals(8), '%5.2f'));
        set(handles.txtCurMeas250Val, 'String', num2str(meanvals(11), '%5.2f'));
    else
        set(handles.txtCurMeas210Val, 'String', 'Err');
        set(handles.txtCurMeas250Val, 'String', 'Err');
    end
catch
    s = lasterror;
    disp(['Error when working with numerical values: ' s.message])
end
        
% Update the position plots
try
    if (length(CB_SVBPS0210H) == length(xrange_bpm)) && (length(CB_SVBPS0250H) == length(xrange_bpm))
        cla(handles.axHorPulses);
        hold(handles.axHorPulses, 'on');
        plot(handles.axHorPulses, xrange_bpm, CB_SVBPS0210H, '.-', 'Color', [0.626 0.322 0.177], 'MarkerSize', 13);
        plot(handles.axHorPulses, xrange_bpm, CB_SVBPS0250H, '.-', 'Color', [0.0 0.745 0.433], 'MarkerSize', 13);
        hold(handles.axHorPulses, 'off');
        set(handles.axHorPulses, 'XLim', xl, 'YLim', [-10 10], 'YGrid', 'on', 'XGrid', 'on');
        set(get(handles.axHorPulses, 'YLabel'), 'String', 'Position [mm]');
        legend(handles.axHorPulses, control(4).name, control(7).name, 'Location', 'NorthEast');
    else
        cla(handles.axHorPulses);
        text(0, 0, ['Signal lengths: ' num2str(length(CB_SVBPS0210H)) ' and ' num2str(length(CB_SVBPS0250H))], ...
            'Parent', handles.axHorPulses, 'HorizontalAlignment', 'left');
    end
    if (length(CB_SVBPS0210V) == length(xrange_bpm)) && (length(CB_SVBPS0250V) == length(xrange_bpm))
        cla(handles.axVerPulses);
        hold(handles.axVerPulses, 'on');
        plot(handles.axVerPulses, xrange_bpm, CB_SVBPS0210V, '.-', 'Color', [0.626 0.322 0.177], 'MarkerSize', 13);
        plot(handles.axVerPulses, xrange_bpm, CB_SVBPS0250V, '.-', 'Color', [0.0 0.745 0.433], 'MarkerSize', 13);
        hold(handles.axVerPulses, 'off');
        set(handles.axVerPulses, 'XLim', xl, 'YLim', [-10 10], 'YGrid', 'on', 'XGrid', 'on');
        set(get(handles.axVerPulses, 'YLabel'), 'String', 'Position [mm]');
        set(get(handles.axVerPulses, 'XLabel'), 'String', 'Time [ns]');
        legend(handles.axVerPulses, control(6).name, control(9).name, 'Location', 'NorthEast');
    else
        cla(handles.axVerPulses);
        text(0, 0, ['Signal lengths: ' num2str(length(CB_SVBPS0210V)) ' and ' num2str(length(CB_SVBPS0250V))], ...
            'Parent', handles.axVerPulses, 'HorizontalAlignment', 'left');
    end
catch
    s = lasterror;
    disp(['Error when plotting position samples: ' s.message]);
end

% Power production plots
try
    % Form factor
    F = str2double(get(handles.edtPowerProdFF, 'String'));
    %PPred = 0.5 * 0.187 * F^2 * commonBpm(edgesBpm(1):edgesBpm(2)).^2;
    PPred = 0.5 * 0.187 * F^2 * commonBpm.^2;
    PLeft = powPulseL(edgesRf(1):edgesRf(2));
    PRight = powPulseR(edgesRf(1):edgesRf(2));
    xreal = linspace(edgesBpm(1)/samples_bpm*t_bpm, edgesBpm(2)/samples_bpm*t_bpm, length(PLeft));
    %xpred = linspace(edgesRf(1), edgesRf(2), length(PPred));
    
    % Power amplitude + prediction
    cla(handles.axPowerProd);
    hold(handles.axPowerProd, 'on');
    %plot(handles.axPowerProd, powPulseL, 'b.', 'MarkerSize', 12);
    %plot(handles.axPowerProd, powPulseR, 'r.', 'MarkerSize', 12);
    plot(handles.axPowerProd, xreal, PLeft, 'b.', 'MarkerSize', 12);
    plot(handles.axPowerProd, xreal, PRight, 'r.', 'MarkerSize', 12);
    plot(handles.axPowerProd, xrange_bpm, PPred, 'k');
    hold(handles.axPowerProd, 'off');
    xspace = 0.1*(edgesRf(2)-edgesRf(1));
    set(handles.axPowerProd, 'YLim', [0 ceil(maxRf*1.2)], 'Xlim', xl, ...
        'YGrid', 'on', 'XGrid', 'on');
    %set(handles.axPowerProd, 'YLim', [0 ceil(maxRf*1.2)], 'XLim', ...
    %    [edgesRf(1)-xspace edgesRf(2)+xspace], 'YGrid', 'on', 'XGrid', 'on');
    set(get(handles.axPowerProd, 'YLabel'), 'String', 'Power [MW]');
    legend(handles.axPowerProd, 'P_{left}', 'P_{right}', 'P_{pred}', 'Location', 'NorthEast');
    
    % Phase
    %ymin = min(min(phaseL(windowRf)), min(phaseR(windowRf)-shiftPhase));
    %ymax = max(max(phaseL(windowRf)), max(phaseL(windowRf)));
    ymin = min(phaseL(edgesRf(1):edgesRf(2)));
    ymax = max(phaseL(edgesRf(1):edgesRf(2)));
    yl = [ymin-(ymax-ymin)*0.4, ymax+(ymax-ymin)*0.4];
    cla(handles.axPowerPhase);
    hold(handles.axPowerPhase, 'on');
    plot(handles.axPowerPhase, xreal, phaseL(edgesRf(1):edgesRf(2)), 'b.-', 'MarkerSize', 12);
    plot(handles.axPowerPhase, xreal, phaseR(edgesRf(1):edgesRf(2))-shiftPhase, 'r.-', 'MarkerSize', 12);
    %plot(handles.axPowerPhase, phaseL, 'b.-', 'MarkerSize', 12);
    %plot(handles.axPowerPhase, phaseR-shiftPhase, 'r.-', 'MarkerSize', 12);
    hold(handles.axPowerPhase, 'off');
    set(handles.axPowerPhase, 'XLim', xl, 'YLim', yl', 'YGrid', 'on', 'XGrid', 'on');
    %set(handles.axPowerPhase, 'XLim', [edgesRf(1)-xspace edgesRf(2)+xspace], ...
    %    'Ylim', yl, 'YGrid', 'on', 'XGrid', 'on');
    set(get(handles.axPowerPhase, 'YLabel'), 'String', 'Phase [deg]');
    set(get(handles.axPowerPhase, 'XLabel'), 'String', 'Time [ns]');
    legend(handles.axPowerPhase, '\phi_{left}', '\phi_{right}', 'Location', 'NorthEast');
catch
    s = lasterror;
    disp(['Error when plotting power production: ' s.message]);
end