% input
E = 120;
phi_H_REQ = 90 * pi/180;
phi_V_REQ = 80 * pi/180;

% minimization options
options = zeros(10,1);
tolerance = 1e-8;
options = zeros(10,1);
options(1) = 0;
options(2) = tolerance;
options(5) = 0;
options(10) = 10000;

% minimization
I = fmins('merit_function_phis',[1 1], options, [], E, phi_H_REQ, phi_V_REQ)
% options = optimset('TolFun', tolerance, 'TolX', tolerance, 'MaxIter', 10000);
% I = fminsearch('merit_function_phis',[1 1; E 0; phi_H_REQ 0; phi_V_REQ 0], options);

% show result
[phi_H, phi_V] = calc_FODO_TBL_func(I(1), I(2), E);
phi_H * 180/pi
phi_V * 180/pi
